<?php
 ini_set('display_errors', 'On');
 error_reporting(E_ALL | E_STRICT);
 $title = 'Writing Contract Tracker: Create User';
 
 require 'imports/utils.php';
 $db_connection = null;

 $adding = array_key_exists('action', $_POST) && ($_POST['action'] == 'add');
 $success = !$adding;
 if($adding)
   $db_connection = new contract_db();
 if($db_connection && $db_connection->working &&
  array_key_exists('name_last', $_POST) &&
  array_key_exists('name_first', $_POST) &&
  array_key_exists('email', $_POST) &&
  array_key_exists('monitor_email', $_POST))
 {
  $statement = $db_connection->prepare('INSERT INTO people (name_last, name_first, email, monitor_email, ' .
   'option_one_week, option_show_future, option_separate_weeks, option_separate_commitments, option_allow_delete, option_fail_mail, option_auto_vacation) VALUES (?, ?, ?, ?, ?, ?, ?, ?, false, ?, ?)');
  $option_one_week = isset($_POST['option_one_week']);
  $option_show_future = isset($_POST['option_show_future']);
  $option_separate_weeks = isset($_POST['option_separate_weeks']);
  $option_separate_commitments = isset($_POST['option_separate_commitments']);
  $option_fail_mail = isset($_POST['option_fail_mail']);
  $option_auto_vacation = isset($_POST['option_auto_vacation']); 
  $statement->bind_param('ssssiiiiii', $_POST['name_last'], $_POST['name_first'], $_POST['email'], $_POST['monitor_email'],
   $option_one_week, $option_show_future, $option_separate_weeks, $option_separate_commitments, $option_fail_mail,
   $option_auto_vacation);
  $statement->execute();

  if($db_connection->errno)
   $db_connection->status = 'Failed to insert contract: ' . $db_connection->error;
  else
   $success = true;
 }

 if($success)
 {
  if($adding)
  {
?>
    <p>Successfully added user!</p>
    <table>
     <tr><th>First Name:</th><td><?=htmlspecialchars($_POST['name_first'])?></td></tr>
     <tr><th>Last Name:</th><td><?=htmlspecialchars($_POST['name_last'])?></td></tr>
     <tr><th>Email Address:</th><td><?=htmlspecialchars($_POST['email'])?></td></tr>
     <tr><th>Monitor Email Address:</th><td><?=htmlspecialchars($_POST['monitor_email'])?></td></tr>
     <tr><th>Limit Summary to One Week:</th><td><?=isset($_POST['option_one_week']) ? 'Yes' : 'No';?></td></tr>
     <tr><th>Show Future Commitments:</th><td><?=isset($_POST['option_show_future']) ? 'Yes' : 'No';?></td></tr>
     <tr><th>Show Week Separators:</th><td><?=isset($_POST['option_separate_weeks']) ? 'Yes' : 'No';?></td></tr>
     <tr><th>Show Commitments Separately:</th><td><?=isset($_POST['option_separate_commitments']) ? 'Yes' : 'No';?></td></tr>
     <tr><th>Negative Mail:</th><td><?=isset($_POST['option_fail_mail']) ? 'Yes' : 'No';?></td></tr>
     <tr><th>Auto Vacation:</th><td><?=isset($_POST['option_auto_vacation']) ? 'Yes' : 'No';?></td></tr>
    </table>
<?php
  }
  else
  {
   require 'imports/top.php';
?>
   <form name="create_user" action="create_user.php" method="POST">
    <input type="hidden" name="action" value="add"/>
    <table>
     <tr><th>First Name:</th><td><input type="text" name="name_first" /></td></tr>
     <tr><th>Last Name:</th><td><input type="text" name="name_last" /></td></tr>
     <tr><th>Email Address:</th><td><input type="text" name="email" /></td></tr>
     <tr><th>Monitor Email Address:</th><td><input type="text" name="monitor_email" /></td></tr>
     <tr><th>Limit Summary to One Week:</th><td><input type="checkbox" name="option_one_week" value="1"/></td></tr>
     <tr><th>Show Future Commitments:</th><td><input type="checkbox" name="option_show_future" value="1" checked="checked"/></td></tr>
     <tr><th>Show Week Separators:</th><td><input type="checkbox" name="option_separate_weeks" value="1" checked="checked"/></td></tr>
     <tr><th>Show Commitments Separately:</th><td><input type="checkbox" name="option_separate_commitments" value="1"/></td></tr>
     <tr><th>Negative Mail:</th><td><input type="checkbox" name="option_fail_mail" value="1"/></td></tr>
     <tr><th>Auto Vacation:</th><td><input type="checkbox" name="option_auto_vacation" value="1"></td></tr>
     <tr><th></th><td><input type="button" id="post_self" value="Create" /></td></tr>
    </table>    
   </form>
<?php
   require 'imports/bottom.php';
  }
 }
 else
 {
  if(!$adding)
   require 'imports/bottom.php';
?>

  <p>Something went wrong.  Contact Edward and he'll try to fix it.</p>
<?php
  if(!$adding)
   require 'imports/bottom.php';
 }
?>
