<?php
 require_once 'imports/utils.php';
 require_once 'imports/messages.php';
 
 $db_connection = new contract_db();
 
 $unfinished_tasks = $db_connection->query('SELECT t.id, option_fail_mail, option_auto_vacation ' .
  'FROM people AS p INNER JOIN contracts AS cc INNER JOIN commitments AS c INNER JOIN tasks AS t ' .
  'ON p.id=cc.owner_id AND cc.id=c.contract_id AND c.id=t.commitment_id ' .
  'WHERE done=0 AND DATE_ADD(t.start, INTERVAL c.length_days DAY) = DATE(NOW());');

 while($unfinished_task = $unfinished_tasks->fetch_assoc())
 {
 	if($unfinished_task['option_auto_vacation'])
 	{
 		$vacations_row = $db_connection->query('SELECT cc.id, vacations, vacations_used ' .
 			'FROM people AS p INNER JOIN contracts AS cc  INNER JOIN commitments AS c INNER JOIN tasks AS t ' .
 			'ON p.id=cc.owner_id AND cc.id=c.contract_id AND c.id=t.commitment_id ' .
 			'WHERE t.id=' . $unfinished_task['id'] . ';');
 		$vacations_info = $vacations_row->fetch_assoc();
 
 		if($vacations_info['vacations_used'] < $vacations_info['vacations'])
 		{
 			$db_connection->query('UPDATE contracts SET vacations_used=' .
 				($vacations_info['vacations_used'] + 1) . ' WHERE id=' .
 				$vacations_info['id'] . ';');
 			$db_connection->query('UPDATE tasks SET done=1, vacation=1 ' .
 				'WHERE id=' . $unfinished_task['id'] . ';');

   		message_vacation_writer($db_connection, $unfinished_task['id']);
   		message_vacation_monitor($db_connection, $unfinished_task['id']); 
 
 			continue;
 		}
 	}
 	if($unfinished_task['option_fail_mail'])
 	 message_failure_writer($db_connection, $unfinished_task['id']);
 	message_failure_monitor($db_connection, $unfinished_task['id']);
 }
 
 $finished_contracts = $db_connection->query('SELECT id FROM contracts ' .
  'WHERE id NOT IN ' .
   '(SELECT DISTINCT cc.id ' .
   'FROM contracts AS cc INNER JOIN commitments AS c INNER JOIN tasks AS t ' .
   'ON cc.id=c.contract_id AND c.id=t.commitment_id WHERE done=0) ' .
  'AND DATE_ADD(contracts.end, INTERVAL 1 DAY)=DATE(NOW());');

 while($contract = $finished_contracts->fetch_assoc())
 {
  message_success_contract_writer($db_connection, $contract['id']);
  message_success_contract_monitor($db_connection, $contract['id']);
 }

 $unfinished_contracts = $db_connection->query('SELECT DISTINCT cc.id, option_fail_mail ' .
  'FROM people AS p INNER JOIN contracts AS cc INNER JOIN commitments AS c INNER JOIN tasks AS t ' .
  'ON p.id=cc.owner_id AND cc.id=c.contract_id AND c.id=t.commitment_id ' .
  'WHERE done=0 AND DATE_ADD(cc.end, INTERVAL 1 DAY)=DATE(NOW());');
 
 while($contract = $unfinished_contracts->fetch_assoc())
 {
  if($contract['option_fail_mail'])
   message_failure_contract_writer($db_connection, $contract['id']);
  message_failure_contract_monitor($db_connection, $contract['id']);
 }  
?>