<?php
 require_once 'imports/utils.php';
 require_once 'imports/messages.php';

 if(!array_key_exists('request_type', $_POST) ||
  !array_key_exists('task_id', $_POST))
 {
    echo 'failed';
    return;
 }

 $db_connection = new contract_db(); 
 $task_id = (int)$_POST['task_id'];

 $query_result = $db_connection->query(
 'SELECT tasks.start, commitments.length_days, commitments.daily_limit, commitments.last_day, contracts.vacations, contracts.vacations_used, ' .
 'contracts.allow_makeups, contracts.id AS contract_id, tasks.done, tasks.vacation ' .
 'FROM tasks JOIN ' .
 '(commitments JOIN contracts ON commitments.contract_id = contracts.id) ON commitments.id = tasks.commitment_id ' .
 'WHERE tasks.id = ' . $task_id . ';');

 if($query_result && ($query_row = $query_result->fetch_assoc()))
 {
  $start_date = new simple_date($query_row['start']);
  $end_date = clone $start_date;
  $end_date->add_days($query_row['length_days'] - 1);
  $today = new simple_date(date('Y-m-d'));
 }
 else
 {
  echo 'failed';
  return;
 }

 if($_POST['request_type'] == 'vacation')
 {    
  if(($query_row['vacations_used'] >= $query_row['vacations']) ||
   $query_row['done'] ||
   $today->lt($start_date))
  {
   echo 'failed';
   return;
  }
    
  $db_connection->query('UPDATE contracts SET vacations_used = ' .
   ($query_row['vacations_used'] + 1) .
   ' WHERE id = ' . $query_row['contract_id'] . ';');
  $db_connection->query('UPDATE tasks SET done = 1, vacation = 1 WHERE id = ' .
   $task_id . ';');
   
   message_vacation_writer($db_connection, $task_id);
   message_vacation_monitor($db_connection, $task_id);
 }
 else if($_POST['request_type'] == 'done')
 {
  $last_completion = (($query_row['daily_limit'] > 0) && ($query_row['last_day'] != null)) ?
   new simple_date($query_row['last_day']) : null;
 
  if($today->lt($start_date) || $end_date->lt($today) ||
   ($last_completion && !$last_completion->lt($today)))
  {
   echo 'failed';
   return;
  }

  $db_connection->query('UPDATE tasks SET done = 1 WHERE id = ' .
   $task_id . ';');

  $db_connection->query('UPDATE commitments SET last_day="' . $today . '" WHERE id IN ' .
   '(SELECT commitment_id AS id FROM tasks WHERE id=' . $task_id . ');');
   
   message_success_writer($db_connection, $task_id);
   message_success_monitor($db_connection, $task_id);
 }
 else if($_POST['request_type'] == 'make_up')
 {
  if(!$end_date->lt($today) || !$query_row['allow_makeups'])
  {
   echo 'failed';
   return;
  }

  $db_connection->query('UPDATE tasks SET done = 1 WHERE id = ' . 
   $task_id . ';');

   message_makeup_writer($db_connection, $task_id);
   message_makeup_monitor($db_connection, $task_id);
 }
 else if($_POST['request_type'] == 'make_up_vacation')
 {
  if(!$query_row['done'] || !$query_row['vacation'] || !$query_row['allow_makeups'])
  {
   echo 'failed';
   return;
  }

  if($query_row['vacations_used'] > 0)
  {
   $db_connection->query('UPDATE contracts SET vacations_used = ' .
    ($query_row['vacations_used'] - 1) .
    ' WHERE id = ' . $query_row['contract_id'] . ';');
  }
  $db_connection->query('UPDATE tasks SET vacation = 0 WHERE id = ' .
   $task_id . ';');
   
   message_vacation_makeup_writer($db_connection, $task_id);
   message_vacation_makeup_monitor($db_connection, $task_id);
 }
 else
 {
    echo 'failed';
    return;
 }

 echo $_POST['request_type'];
?>